<template>
  <svg id="chart" :viewBox="viewbox"></svg>
</template>

<script>
import * as d3 from 'd3'

export default {
  name: 'Chart',
  props: {
    width: {
      default: 700,
      type: Number,
    },
    height: {
      default: 500,
      type: Number,
    },
    data: {
      required: true,
      type: Array,
    },
  },

  computed: {
    viewbox() {
      return `0 0 ${this.width} ${this.height}`
    },
    svg() {
      return d3.select('#chart')
    },
    xScale() {
      return d3
        .scaleBand()
        .domain(d3.range(this.data.length))
        .range([40, this.width - 40])
        .padding(0.1)
    },
    yScale() {
      return d3
        .scaleLinear()
        .domain([0, d3.max(this.data, (data) => data.value)])
        .nice()
        .range([this.height - 30, 30])
    },
    xAxis() {
      return (g) =>
        g
          .attr('transform', `translate(0, ${this.height - 30})`)
          .call(
            d3
              .axisBottom(this.xScale)
              .tickFormat((i) => this.data[i].name)
              .tickSizeOuter(0)
          )
          .call((g) =>
            g
              .append('text')
              .attr('x', this.width - 40)
              .attr('fill', 'currentColor')
              .attr('text-anchor', 'start')
              .text('Answer')
          )
    },
    yAxis() {
      return (g) =>
        g
          .attr('transform', `translate(40, 0)`)
          .call(d3.axisLeft(this.yScale).ticks(15))
          .call((g) =>
            g
              .append('text')
              .attr('x', -40)
              .attr('y', 10)
              .attr('fill', 'currentColor')
              .attr('text-anchor', 'start')
              .text('Frequency')
          )
    },
  },

  watch: {
    data: {
      deep: true,
      handler() {
        this.plot()
      },
    },
  },

  mounted() {
    this.plot()
  },

  methods: {
    plot() {
      this.svg.selectAll('g').remove()

      this.svg
        .append('g')
        .attr('fill', 'steelblue')
        .selectAll('rect')
        .data(this.data)
        .join('rect')
        .attr('x', (data, index) => this.xScale(index))
        .attr('y', (data) => this.yScale(data.value))
        .attr('height', (data) => this.yScale(0) - this.yScale(data.value))
        .attr('width', this.xScale.bandwidth())

      this.svg.append('g').call(this.xAxis)
      this.svg.append('g').call(this.yAxis)
    },
  },
}
</script>

<style>
#chart {
  border: 1px solid black;
}
</style>
